# Generated from NFA_grammar.g4 by ANTLR 4.8
# encoding: utf-8
from antlr4 import *
from io import StringIO
import sys
if sys.version_info[1] > 5:
	from typing import TextIO
else:
	from typing.io import TextIO


def serializedATN():
    with StringIO() as buf:
        buf.write("\3\u608b\ua72a\u8133\ub9ed\u417c\u3be7\u7786\u5964\3\f")
        buf.write(":\4\2\t\2\4\3\t\3\4\4\t\4\4\5\t\5\4\6\t\6\4\7\t\7\3\2")
        buf.write("\3\2\7\2\21\n\2\f\2\16\2\24\13\2\3\2\3\2\3\3\3\3\3\3\3")
        buf.write("\3\5\3\34\n\3\3\4\3\4\3\4\3\4\3\4\3\4\3\4\3\4\3\5\3\5")
        buf.write("\3\5\3\5\7\5*\n\5\f\5\16\5-\13\5\3\5\5\5\60\n\5\3\5\3")
        buf.write("\5\3\6\3\6\3\6\3\6\3\7\3\7\3\7\2\2\b\2\4\6\b\n\f\2\2\2")
        buf.write("\67\2\16\3\2\2\2\4\33\3\2\2\2\6\35\3\2\2\2\b%\3\2\2\2")
        buf.write("\n\63\3\2\2\2\f\67\3\2\2\2\16\22\5\4\3\2\17\21\5\6\4\2")
        buf.write("\20\17\3\2\2\2\21\24\3\2\2\2\22\20\3\2\2\2\22\23\3\2\2")
        buf.write("\2\23\25\3\2\2\2\24\22\3\2\2\2\25\26\5\n\6\2\26\3\3\2")
        buf.write("\2\2\27\30\7\3\2\2\30\31\7\4\2\2\31\34\5\f\7\2\32\34\3")
        buf.write("\2\2\2\33\27\3\2\2\2\33\32\3\2\2\2\34\5\3\2\2\2\35\36")
        buf.write("\7\5\2\2\36\37\5\f\7\2\37 \7\t\2\2 !\5\f\7\2!\"\7\6\2")
        buf.write("\2\"#\7\4\2\2#$\5\b\5\2$\7\3\2\2\2%/\7\7\2\2&+\5\f\7\2")
        buf.write("\'(\7\t\2\2(*\5\f\7\2)\'\3\2\2\2*-\3\2\2\2+)\3\2\2\2+")
        buf.write(",\3\2\2\2,\60\3\2\2\2-+\3\2\2\2.\60\3\2\2\2/&\3\2\2\2")
        buf.write("/.\3\2\2\2\60\61\3\2\2\2\61\62\7\b\2\2\62\t\3\2\2\2\63")
        buf.write("\64\7\n\2\2\64\65\7\4\2\2\65\66\5\b\5\2\66\13\3\2\2\2")
        buf.write("\678\7\13\2\28\r\3\2\2\2\6\22\33+/")
        return buf.getvalue()


class NFA_grammarParser ( Parser ):

    grammarFileName = "NFA_grammar.g4"

    atn = ATNDeserializer().deserialize(serializedATN())

    decisionsToDFA = [ DFA(ds, i) for i, ds in enumerate(atn.decisionToState) ]

    sharedContextCache = PredictionContextCache()

    literalNames = [ "<INVALID>", "'init'", "'='", "'('", "')'", "'{'", 
                     "'}'", "','" ]

    symbolicNames = [ "<INVALID>", "INIT", "EQUALS", "LEFT_PARENTHESIS", 
                      "RIGHT_PARENTHESIS", "LEFT_BRACKET", "RIGHT_BRACKET", 
                      "COMMA", "FINAL", "STATE", "WS" ]

    RULE_start = 0
    RULE_init = 1
    RULE_production = 2
    RULE_stateset = 3
    RULE_final = 4
    RULE_statename = 5

    ruleNames =  [ "start", "init", "production", "stateset", "final", "statename" ]

    EOF = Token.EOF
    INIT=1
    EQUALS=2
    LEFT_PARENTHESIS=3
    RIGHT_PARENTHESIS=4
    LEFT_BRACKET=5
    RIGHT_BRACKET=6
    COMMA=7
    FINAL=8
    STATE=9
    WS=10

    def __init__(self, input:TokenStream, output:TextIO = sys.stdout):
        super().__init__(input, output)
        self.checkVersion("4.8")
        self._interp = ParserATNSimulator(self, self.atn, self.decisionsToDFA, self.sharedContextCache)
        self._predicates = None




    class StartContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def init(self):
            return self.getTypedRuleContext(NFA_grammarParser.InitContext,0)


        def final(self):
            return self.getTypedRuleContext(NFA_grammarParser.FinalContext,0)


        def production(self, i:int=None):
            if i is None:
                return self.getTypedRuleContexts(NFA_grammarParser.ProductionContext)
            else:
                return self.getTypedRuleContext(NFA_grammarParser.ProductionContext,i)


        def getRuleIndex(self):
            return NFA_grammarParser.RULE_start

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterStart" ):
                listener.enterStart(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitStart" ):
                listener.exitStart(self)




    def start(self):

        localctx = NFA_grammarParser.StartContext(self, self._ctx, self.state)
        self.enterRule(localctx, 0, self.RULE_start)
        self._la = 0 # Token type
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 12
            self.init()
            self.state = 16
            self._errHandler.sync(self)
            _la = self._input.LA(1)
            while _la==NFA_grammarParser.LEFT_PARENTHESIS:
                self.state = 13
                self.production()
                self.state = 18
                self._errHandler.sync(self)
                _la = self._input.LA(1)

            self.state = 19
            self.final()
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class InitContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def INIT(self):
            return self.getToken(NFA_grammarParser.INIT, 0)

        def EQUALS(self):
            return self.getToken(NFA_grammarParser.EQUALS, 0)

        def statename(self):
            return self.getTypedRuleContext(NFA_grammarParser.StatenameContext,0)


        def getRuleIndex(self):
            return NFA_grammarParser.RULE_init

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterInit" ):
                listener.enterInit(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitInit" ):
                listener.exitInit(self)




    def init(self):

        localctx = NFA_grammarParser.InitContext(self, self._ctx, self.state)
        self.enterRule(localctx, 2, self.RULE_init)
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 25
            self._errHandler.sync(self)
            token = self._input.LA(1)
            if token in [NFA_grammarParser.INIT]:
                self.state = 21
                self.match(NFA_grammarParser.INIT)
                self.state = 22
                self.match(NFA_grammarParser.EQUALS)
                self.state = 23
                self.statename()
                pass
            elif token in [NFA_grammarParser.LEFT_PARENTHESIS, NFA_grammarParser.FINAL]:
                pass
            else:
                raise NoViableAltException(self)

        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class ProductionContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def LEFT_PARENTHESIS(self):
            return self.getToken(NFA_grammarParser.LEFT_PARENTHESIS, 0)

        def statename(self, i:int=None):
            if i is None:
                return self.getTypedRuleContexts(NFA_grammarParser.StatenameContext)
            else:
                return self.getTypedRuleContext(NFA_grammarParser.StatenameContext,i)


        def COMMA(self):
            return self.getToken(NFA_grammarParser.COMMA, 0)

        def RIGHT_PARENTHESIS(self):
            return self.getToken(NFA_grammarParser.RIGHT_PARENTHESIS, 0)

        def EQUALS(self):
            return self.getToken(NFA_grammarParser.EQUALS, 0)

        def stateset(self):
            return self.getTypedRuleContext(NFA_grammarParser.StatesetContext,0)


        def getRuleIndex(self):
            return NFA_grammarParser.RULE_production

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterProduction" ):
                listener.enterProduction(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitProduction" ):
                listener.exitProduction(self)




    def production(self):

        localctx = NFA_grammarParser.ProductionContext(self, self._ctx, self.state)
        self.enterRule(localctx, 4, self.RULE_production)
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 27
            self.match(NFA_grammarParser.LEFT_PARENTHESIS)
            self.state = 28
            self.statename()
            self.state = 29
            self.match(NFA_grammarParser.COMMA)
            self.state = 30
            self.statename()
            self.state = 31
            self.match(NFA_grammarParser.RIGHT_PARENTHESIS)
            self.state = 32
            self.match(NFA_grammarParser.EQUALS)
            self.state = 33
            self.stateset()
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class StatesetContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def LEFT_BRACKET(self):
            return self.getToken(NFA_grammarParser.LEFT_BRACKET, 0)

        def RIGHT_BRACKET(self):
            return self.getToken(NFA_grammarParser.RIGHT_BRACKET, 0)

        def statename(self, i:int=None):
            if i is None:
                return self.getTypedRuleContexts(NFA_grammarParser.StatenameContext)
            else:
                return self.getTypedRuleContext(NFA_grammarParser.StatenameContext,i)


        def COMMA(self, i:int=None):
            if i is None:
                return self.getTokens(NFA_grammarParser.COMMA)
            else:
                return self.getToken(NFA_grammarParser.COMMA, i)

        def getRuleIndex(self):
            return NFA_grammarParser.RULE_stateset

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterStateset" ):
                listener.enterStateset(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitStateset" ):
                listener.exitStateset(self)




    def stateset(self):

        localctx = NFA_grammarParser.StatesetContext(self, self._ctx, self.state)
        self.enterRule(localctx, 6, self.RULE_stateset)
        self._la = 0 # Token type
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 35
            self.match(NFA_grammarParser.LEFT_BRACKET)
            self.state = 45
            self._errHandler.sync(self)
            token = self._input.LA(1)
            if token in [NFA_grammarParser.STATE]:
                self.state = 36
                self.statename()
                self.state = 41
                self._errHandler.sync(self)
                _la = self._input.LA(1)
                while _la==NFA_grammarParser.COMMA:
                    self.state = 37
                    self.match(NFA_grammarParser.COMMA)
                    self.state = 38
                    self.statename()
                    self.state = 43
                    self._errHandler.sync(self)
                    _la = self._input.LA(1)

                pass
            elif token in [NFA_grammarParser.RIGHT_BRACKET]:
                pass
            else:
                raise NoViableAltException(self)

            self.state = 47
            self.match(NFA_grammarParser.RIGHT_BRACKET)
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class FinalContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def FINAL(self):
            return self.getToken(NFA_grammarParser.FINAL, 0)

        def EQUALS(self):
            return self.getToken(NFA_grammarParser.EQUALS, 0)

        def stateset(self):
            return self.getTypedRuleContext(NFA_grammarParser.StatesetContext,0)


        def getRuleIndex(self):
            return NFA_grammarParser.RULE_final

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterFinal" ):
                listener.enterFinal(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitFinal" ):
                listener.exitFinal(self)




    def final(self):

        localctx = NFA_grammarParser.FinalContext(self, self._ctx, self.state)
        self.enterRule(localctx, 8, self.RULE_final)
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 49
            self.match(NFA_grammarParser.FINAL)
            self.state = 50
            self.match(NFA_grammarParser.EQUALS)
            self.state = 51
            self.stateset()
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx


    class StatenameContext(ParserRuleContext):

        def __init__(self, parser, parent:ParserRuleContext=None, invokingState:int=-1):
            super().__init__(parent, invokingState)
            self.parser = parser

        def STATE(self):
            return self.getToken(NFA_grammarParser.STATE, 0)

        def getRuleIndex(self):
            return NFA_grammarParser.RULE_statename

        def enterRule(self, listener:ParseTreeListener):
            if hasattr( listener, "enterStatename" ):
                listener.enterStatename(self)

        def exitRule(self, listener:ParseTreeListener):
            if hasattr( listener, "exitStatename" ):
                listener.exitStatename(self)




    def statename(self):

        localctx = NFA_grammarParser.StatenameContext(self, self._ctx, self.state)
        self.enterRule(localctx, 10, self.RULE_statename)
        try:
            self.enterOuterAlt(localctx, 1)
            self.state = 53
            self.match(NFA_grammarParser.STATE)
        except RecognitionException as re:
            localctx.exception = re
            self._errHandler.reportError(self, re)
            self._errHandler.recover(self, re)
        finally:
            self.exitRule()
        return localctx





